try
{
if (Get-Module -ListAvailable -Name Az.Accounts) 
{
} 
else 
{
[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12
""
"Configuring Connection to Azure..  This may take a few minutes.  Please Wait.."
Install-PackageProvider -Name NuGet -Force
""
"Loading Please Wait... This may take a while"
Install-Module -Name Az.Accounts -Force
Install-Module -Name Az.Resources -Force
}

#Disable IE ESC so that login screen will load correctly
$AdminKey = "HKLM:\SOFTWARE\Microsoft\Active Setup\Installed Components\{A509B1A7-37EF-4b3f-8CFC-4F3A74704073}"
$UserKey = "HKLM:\SOFTWARE\Microsoft\Active Setup\Installed Components\{A509B1A8-37EF-4b3f-8CFC-4F3A74704073}"
Set-ItemProperty -Path $AdminKey -Name "IsInstalled" -Value 0 -Force
Set-ItemProperty -Path $UserKey -Name "IsInstalled" -Value 0 -Force
Stop-Process -Name Explorer -Force


#Connect to Azure 
""
"Please Sign Into Azure with Admin Account...  Dialog Box may be hidden behind open windows.  Check Taskbar"
""
"Don't Close Powershell Window"
$Azure = Connect-AzAccount -WarningAction:SilentlyContinue

#Create Service Principle
$sp = New-AzADServicePrincipal -DisplayName "Azure Maintenance Mode Scheduler" 
$secret = $sp.PasswordCredentials.SecretText
$AppID = $sp.AppId
$TennantID = Get-AzTenant 

#Gets Azure Management Group.  Use other script for one Subscription 
$mg = Get-AzManagementGroup 

#Create Role Definition

$AzRole = Get-AzRoleDefinition -Name "Azure Maintenance Mode Scheduler Role" -WarningAction:SilentlyContinue
if(($AzRole | Measure-Object).Count -eq 0)
{
$role = [Microsoft.Azure.Commands.Resources.Models.Authorization.PSRoleDefinition]::new()
$role.Name = 'Azure Maintenance Mode Scheduler Role'
$role.Description = 'Azure Maintenance Mode Scheduler Role'
$role.IsCustom = $true
$perms = 'Microsoft.Insights/ScheduledQueryRules/Write','Microsoft.Insights/ScheduledQueryRules/Read'
$perms += 'Microsoft.Insights/ScheduledQueryRules/Delete','Microsoft.OperationalInsights/workspaces/*'
$perms += 'Microsoft.Insights/ActionGroups/Read'
$role.Actions = $perms
$subs = $mg.Id
$role.AssignableScopes = $subs


$myRole = New-AzRoleDefinition -Role $role 

$roleAssignment = New-AzRoleAssignment -ObjectId $sp.Id -RoleDefinitionId $myRole.Id -Scope $mg.Id -WarningAction:SilentlyContinue
}
else
{
#Assign SP to Role Definition
$roleAssignment = New-AzRoleAssignment -ObjectId $sp.Id -RoleDefinitionId $AzRole.Id -Scope $mg.Id -WarningAction:SilentlyContinue
}



#Output Values for Application
""
""
""
"Please save the following infomation for the install"
"----------------------------------------------------------------"
""
"  Directory (tenant) ID: " +  $TennantID.Id
"Application (client) ID: " + $AppID
"          Client Secret: " + $secret
""
"----------------------------------------------------------------"
""

$RegKey = New-Item -Path "HKCU:" -Name "AzureMM" -Force
$RegKeyOne = New-ItemProperty -Path "HKCU:\AzureMM" -Name "TenId" -Value $TennantID.Id  -PropertyType "String" -Force
$RegKeyTwo = New-ItemProperty -Path "HKCU:\AzureMM" -Name "AppID" -Value $AppID  -PropertyType "String" -Force
$RegKeyThree = New-ItemProperty -Path "HKCU:\AzureMM" -Name "CliID" -Value $secret  -PropertyType "String" -Force

}
catch
{

"`n"
"**Error** : $PSItem.Exception.Message" 

"`n ** Please contact support@scom2k7.com for help **"

}
# SIG # Begin signature block
# MIITawYJKoZIhvcNAQcCoIITXDCCE1gCAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQUzRMHVFEuyVc+FjZqr8gKeO9s
# F5OgghCjMIIFITCCBAmgAwIBAgIQBcp/irx7cqrd9nDyQ4hSKTANBgkqhkiG9w0B
# AQsFADB8MQswCQYDVQQGEwJHQjEbMBkGA1UECBMSR3JlYXRlciBNYW5jaGVzdGVy
# MRAwDgYDVQQHEwdTYWxmb3JkMRgwFgYDVQQKEw9TZWN0aWdvIExpbWl0ZWQxJDAi
# BgNVBAMTG1NlY3RpZ28gUlNBIENvZGUgU2lnbmluZyBDQTAeFw0xOTA3MzAwMDAw
# MDBaFw0yMjA3MjkyMzU5NTlaMIGSMQswCQYDVQQGEwJVUzEOMAwGA1UEEQwFNDgz
# NTkxETAPBgNVBAgMCE1pY2hpZ2FuMRMwEQYDVQQHDApMYWtlIE9yaW9uMRswGQYD
# VQQJDBI0NTQ4IFRhbmdsZXdvb2QgTG4xFjAUBgNVBAoMDUFNVE0gVGVjaCBJbmMx
# FjAUBgNVBAMMDUFNVE0gVGVjaCBJbmMwggEiMA0GCSqGSIb3DQEBAQUAA4IBDwAw
# ggEKAoIBAQDGLqAiiyZvE8ahsztG35Ht6veI1R0tCIt69BVxNosrbxO9u2xh74sB
# nBNPXrsVyAfVqZFsj+NTHxddPK9YDRT2LTOmDYfJjuj4iAqii843NfDuKYQlGWYD
# 207J8lmQ87Z0T65IeT8GODenVEz2Ab9xYRvCzE4WoeBJJ+DIBVdt/MhgzKHUhE2f
# Hxm0/5XTm4M5JlUYdGNuPCAtK8/Zgh3NhjV6ozPLPyJlNr3ImTwZz2rDihJSkx1K
# bTudPBq51FGSApWyVTfmFe+iTZ8yu1GamQLuUI8lChMc2TWCt9Wa7WsIxTiFgTZn
# HCmTVsp7c2hPTXrbmTT+nBWwFbvfVrypAgMBAAGjggGGMIIBgjAfBgNVHSMEGDAW
# gBQO4TqoUzox1Yq+wbutZxoDha00DjAdBgNVHQ4EFgQUhFsB5V4D6UIAgry8FV8S
# VkKiIZEwDgYDVR0PAQH/BAQDAgeAMAwGA1UdEwEB/wQCMAAwEwYDVR0lBAwwCgYI
# KwYBBQUHAwMwEQYJYIZIAYb4QgEBBAQDAgQQMEAGA1UdIAQ5MDcwNQYMKwYBBAGy
# MQECAQMCMCUwIwYIKwYBBQUHAgEWF2h0dHBzOi8vc2VjdGlnby5jb20vQ1BTMEMG
# A1UdHwQ8MDowOKA2oDSGMmh0dHA6Ly9jcmwuc2VjdGlnby5jb20vU2VjdGlnb1JT
# QUNvZGVTaWduaW5nQ0EuY3JsMHMGCCsGAQUFBwEBBGcwZTA+BggrBgEFBQcwAoYy
# aHR0cDovL2NydC5zZWN0aWdvLmNvbS9TZWN0aWdvUlNBQ29kZVNpZ25pbmdDQS5j
# cnQwIwYIKwYBBQUHMAGGF2h0dHA6Ly9vY3NwLnNlY3RpZ28uY29tMA0GCSqGSIb3
# DQEBCwUAA4IBAQBSv96qQo5xp23YQ6/lb2GQyQf6OZMTctR2UNMrJaJecFzs3zwt
# BqK93XMLT9kaPTssie/SEk1Z24ZFeCTitzb4VUPcNN714BGnH7hJkgqiDZ3Tc7IU
# Cz1E4AO18e+XUahW4T0vcVKDOuhlkMFqPriuZYZM6kqoq29NFVQzNRapy3Ej45cA
# hS/gUHErRuwAe2h6zNZCLV4Xc+5QQC0s4bCAPsd39eeaEkWq8x3yZVhXOQm6n+u3
# 15wxIi4zUSe1U/g4Jk+Ec+nm3T1CLwuTJ5kE8v6N2xvkL7Yo8pP1uMXu+V8pw/MK
# DssMXW6hZyz+VgP9T5jtEtnqMMoW3vGgLwoDMIIFgTCCBGmgAwIBAgIQOXJEOvki
# t1HX02wQ3TE1lTANBgkqhkiG9w0BAQwFADB7MQswCQYDVQQGEwJHQjEbMBkGA1UE
# CAwSR3JlYXRlciBNYW5jaGVzdGVyMRAwDgYDVQQHDAdTYWxmb3JkMRowGAYDVQQK
# DBFDb21vZG8gQ0EgTGltaXRlZDEhMB8GA1UEAwwYQUFBIENlcnRpZmljYXRlIFNl
# cnZpY2VzMB4XDTE5MDMxMjAwMDAwMFoXDTI4MTIzMTIzNTk1OVowgYgxCzAJBgNV
# BAYTAlVTMRMwEQYDVQQIEwpOZXcgSmVyc2V5MRQwEgYDVQQHEwtKZXJzZXkgQ2l0
# eTEeMBwGA1UEChMVVGhlIFVTRVJUUlVTVCBOZXR3b3JrMS4wLAYDVQQDEyVVU0VS
# VHJ1c3QgUlNBIENlcnRpZmljYXRpb24gQXV0aG9yaXR5MIICIjANBgkqhkiG9w0B
# AQEFAAOCAg8AMIICCgKCAgEAgBJlFzYOw9sIs9CsVw127c0n00ytUINh4qogTQkt
# ZAnczomfzD2p7PbPwdzx07HWezcoEStH2jnGvDoZtF+mvX2do2NCtnbyqTsrkfji
# b9DsFiCQCT7i6HTJGLSR1GJk23+jBvGIGGqQIjy8/hPwhxR79uQfjtTkUcYRZ0YI
# UcuGFFQ/vDP+fmyc/xadGL1RjjWmp2bIcmfbIWax1Jt4A8BQOujM8Ny8nkz+rwWW
# NR9XWrf/zvk9tyy29lTdyOcSOk2uTIq3XJq0tyA9yn8iNK5+O2hmAUTnAU5GU5sz
# YPeUvlM3kHND8zLDU+/bqv50TmnHa4xgk97Exwzf4TKuzJM7UXiVZ4vuPVb+DNBp
# DxsP8yUmazNt925H+nND5X4OpWaxKXwyhGNVicQNwZNUMBkTrNN9N6frXTpsNVzb
# QdcS2qlJC9/YgIoJk2KOtWbPJYjNhLixP6Q5D9kCnusSTJV882sFqV4Wg8y4Z+Lo
# E53MW4LTTLPtW//e5XOsIzstAL81VXQJSdhJWBp/kjbmUZIO8yZ9HE0XvMnsQybQ
# v0FfQKlERPSZ51eHnlAfV1SoPv10Yy+xUGUJ5lhCLkMaTLTwJUdZ+gQek9QmRkpQ
# gbLevni3/GcV4clXhB4PY9bpYrrWX1Uu6lzGKAgEJTm4Diup8kyXHAc/DVL17e8v
# gg8CAwEAAaOB8jCB7zAfBgNVHSMEGDAWgBSgEQojPpbxB+zirynvgqV/0DCktDAd
# BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgGGMA8G
# A1UdEwEB/wQFMAMBAf8wEQYDVR0gBAowCDAGBgRVHSAAMEMGA1UdHwQ8MDowOKA2
# oDSGMmh0dHA6Ly9jcmwuY29tb2RvY2EuY29tL0FBQUNlcnRpZmljYXRlU2Vydmlj
# ZXMuY3JsMDQGCCsGAQUFBwEBBCgwJjAkBggrBgEFBQcwAYYYaHR0cDovL29jc3Au
# Y29tb2RvY2EuY29tMA0GCSqGSIb3DQEBDAUAA4IBAQAYh1HcdCE9nIrgJ7cz0C7M
# 7PDmy14R3iJvm3WOnnL+5Nb+qh+cli3vA0p+rvSNb3I8QzvAP+u431yqqcau8vzY
# 7qN7Q/aGNnwU4M309z/+3ri0ivCRlv79Q2R+/czSAaF9ffgZGclCKxO/WIu6pKJm
# BHaIkU4MiRTOok3JMrO66BQavHHxW/BBC5gACiIDEOUMsfnNkjcZ7Tvx5Dq2+UUT
# JnWvu6rvP3t3O9LEApE9GQDTF1w52z97GA1FzZOFli9d31kWTz9RvdVFGD/tSo7o
# BmF0Ixa1DVBzJ0RHfxBdiSprhTEUxOipakyAvGp4z7h/jnZymQyd/teRCBaho1+V
# MIIF9TCCA92gAwIBAgIQHaJIMG+bJhjQguCWfTPTajANBgkqhkiG9w0BAQwFADCB
# iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
# cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
# BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTgx
# MTAyMDAwMDAwWhcNMzAxMjMxMjM1OTU5WjB8MQswCQYDVQQGEwJHQjEbMBkGA1UE
# CBMSR3JlYXRlciBNYW5jaGVzdGVyMRAwDgYDVQQHEwdTYWxmb3JkMRgwFgYDVQQK
# Ew9TZWN0aWdvIExpbWl0ZWQxJDAiBgNVBAMTG1NlY3RpZ28gUlNBIENvZGUgU2ln
# bmluZyBDQTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAIYijTKFehif
# SfCWL2MIHi3cfJ8Uz+MmtiVmKUCGVEZ0MWLFEO2yhyemmcuVMMBW9aR1xqkOUGKl
# UZEQauBLYq798PgYrKf/7i4zIPoMGYmobHutAMNhodxpZW0fbieW15dRhqb0J+V8
# aouVHltg1X7XFpKcAC9o95ftanK+ODtj3o+/bkxBXRIgCFnoOc2P0tbPBrRXBbZO
# oT5Xax+YvMRi1hsLjcdmG0qfnYHEckC14l/vC0X/o84Xpi1VsLewvFRqnbyNVlPG
# 8Lp5UEks9wO5/i9lNfIi6iwHr0bZ+UYc3Ix8cSjz/qfGFN1VkW6KEQ3fBiSVfQ+n
# oXw62oY1YdMCAwEAAaOCAWQwggFgMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvA
# nfKyA2bLMB0GA1UdDgQWBBQO4TqoUzox1Yq+wbutZxoDha00DjAOBgNVHQ8BAf8E
# BAMCAYYwEgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAwYI
# KwYBBQUHAwgwEQYDVR0gBAowCDAGBgRVHSAAMFAGA1UdHwRJMEcwRaBDoEGGP2h0
# dHA6Ly9jcmwudXNlcnRydXN0LmNvbS9VU0VSVHJ1c3RSU0FDZXJ0aWZpY2F0aW9u
# QXV0aG9yaXR5LmNybDB2BggrBgEFBQcBAQRqMGgwPwYIKwYBBQUHMAKGM2h0dHA6
# Ly9jcnQudXNlcnRydXN0LmNvbS9VU0VSVHJ1c3RSU0FBZGRUcnVzdENBLmNydDAl
# BggrBgEFBQcwAYYZaHR0cDovL29jc3AudXNlcnRydXN0LmNvbTANBgkqhkiG9w0B
# AQwFAAOCAgEATWNQ7Uc0SmGk295qKoyb8QAAHh1iezrXMsL2s+Bjs/thAIiaG20Q
# BwRPvrjqiXgi6w9G7PNGXkBGiRL0C3danCpBOvzW9Ovn9xWVM8Ohgyi33i/klPeF
# M4MtSkBIv5rCT0qxjyT0s4E307dksKYjalloUkJf/wTr4XRleQj1qZPea3FAmZa6
# ePG5yOLDCBaxq2NayBWAbXReSnV+pbjDbLXP30p5h1zHQE1jNfYw08+1Cg4LBH+g
# S667o6XQhACTPlNdNKUANWlsvp8gJRANGftQkGG+OY96jk32nw4e/gdREmaDJhlI
# lc5KycF/8zoFm/lv34h/wCOe0h5DekUxwZxNqfBZslkZ6GqNKQQCd3xLS81wvjqy
# VVp4Pry7bwMQJXcVNIr5NsxDkuS6T/FikyglVyn7URnHoSVAaoRXxrKdsbwcCtp8
# Z359LukoTBh+xHsxQXGaSynsCz1XUNLK3f2eBVHlRHjdAd6xdZgNVCT98E7j4viD
# vXK6yz067vBeF5Jobchh+abxKgoLpbn0nu6YMgWFnuv5gynTxix9vTp3Los3QqBq
# gu07SqqUEKThDfgXxbZaeTMYkuO1dfih6Y4KJR7kHvGfWocj/5+kUZ77OYARzdu1
# xKeogG/lU9Tg46LC0lsa+jImLWpXcBw8pFguo/NbSwfcMlnzh6cabVgxggIyMIIC
# LgIBATCBkDB8MQswCQYDVQQGEwJHQjEbMBkGA1UECBMSR3JlYXRlciBNYW5jaGVz
# dGVyMRAwDgYDVQQHEwdTYWxmb3JkMRgwFgYDVQQKEw9TZWN0aWdvIExpbWl0ZWQx
# JDAiBgNVBAMTG1NlY3RpZ28gUlNBIENvZGUgU2lnbmluZyBDQQIQBcp/irx7cqrd
# 9nDyQ4hSKTAJBgUrDgMCGgUAoHgwGAYKKwYBBAGCNwIBDDEKMAigAoAAoQKAADAZ
# BgkqhkiG9w0BCQMxDAYKKwYBBAGCNwIBBDAcBgorBgEEAYI3AgELMQ4wDAYKKwYB
# BAGCNwIBFTAjBgkqhkiG9w0BCQQxFgQU8JvtWiz0QShvt/jh8HlYDzgHvEIwDQYJ
# KoZIhvcNAQEBBQAEggEAB9eXvd7KhlCYwd5kvT50MjAbaBd+FiVw4ixSG3EN262U
# hbjp/+L6LBByc0vJWVtHVFk24s9pPYqYqkvh/695w0ubsEccrtcLH7jwXrcifiV4
# C3K3+B1Vn/plb9XUu0fuUFddZ/Xd9ipXa2INKA4lofcvdPYTsHUEQfnJ9WvKoXwU
# pkq8vqGjR3+TWCmLktsr/fWdRw93o4+WmHRUX7kT+6AX5ltF/2d1TihrJq2RSH+7
# 0cXGUzY8EJBeVYmdOHD4imx9PH4oL4lSzxE7jvWemMfRkqrmp32CVI5M//AoLGXe
# 4dS7yo/9NEFw9U+1wLJb+KbUmlUcAGhwhCVj2iNEHA==
# SIG # End signature block
